diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_cpols.c openssl-1.0.0q/crypto/x509v3/v3_cpols.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_cpols.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_cpols.c	2017-04-25 16:23:40.874798330 +0200
@@ -56,78 +56,98 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/conf.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 #include "pcy_int.h"
 
 /* Certificate policies extension support: this one is a bit complex... */
 
 static int i2r_certpol(X509V3_EXT_METHOD *method, STACK_OF(POLICYINFO) *pol, BIO *out, int indent);
+#ifndef OPERA_SMALL_VERSION
 static STACK_OF(POLICYINFO) *r2i_certpol(X509V3_EXT_METHOD *method, X509V3_CTX *ctx, char *value);
+#endif
 static void print_qualifiers(BIO *out, STACK_OF(POLICYQUALINFO) *quals, int indent);
 static void print_notice(BIO *out, USERNOTICE *notice, int indent);
+#ifndef OPERA_SMALL_VERSION
 static POLICYINFO *policy_section(X509V3_CTX *ctx,
 				 STACK_OF(CONF_VALUE) *polstrs, int ia5org);
 static POLICYQUALINFO *notice_section(X509V3_CTX *ctx,
 					STACK_OF(CONF_VALUE) *unot, int ia5org);
 static int nref_nos(STACK_OF(ASN1_INTEGER) *nnums, STACK_OF(CONF_VALUE) *nos);
+#endif
 
-const X509V3_EXT_METHOD v3_cpols = {
+CONST_X509V3_EXT_METHOD_item(v3_cpols,
 NID_certificate_policies, 0,ASN1_ITEM_ref(CERTIFICATEPOLICIES),
 0,0,0,0,
 0,0,
 0,0,
 (X509V3_EXT_I2R)i2r_certpol,
-(X509V3_EXT_R2I)r2i_certpol,
+OPERA_R2I_DECLARE((X509V3_EXT_R2I)r2i_certpol),
 NULL
-};
+)
 
-ASN1_ITEM_TEMPLATE(CERTIFICATEPOLICIES) = 
+ASN1_ITEM_TEMPLATE(CERTIFICATEPOLICIES)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, CERTIFICATEPOLICIES, POLICYINFO)
 ASN1_ITEM_TEMPLATE_END(CERTIFICATEPOLICIES)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(CERTIFICATEPOLICIES)
+#endif
 
-ASN1_SEQUENCE(POLICYINFO) = {
-	ASN1_SIMPLE(POLICYINFO, policyid, ASN1_OBJECT),
+ASN1_SEQUENCE(POLICYINFO)
+	ASN1_SIMPLE(POLICYINFO, policyid, ASN1_OBJECT)
 	ASN1_SEQUENCE_OF_OPT(POLICYINFO, qualifiers, POLICYQUALINFO)
-} ASN1_SEQUENCE_END(POLICYINFO)
+ASN1_SEQUENCE_END(POLICYINFO)
 
-IMPLEMENT_ASN1_FUNCTIONS(POLICYINFO)
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
+IMPLEMENT_ASN1_FUNCTIONS1(POLICYINFO)
+#endif
+
+ASN1_ADB_TEMPLATE(policydefault) 
+	ASN1_SIMPLE1(POLICYQUALINFO, d.other, ASN1_ANY)
+ASN1_ADB_TEMPLATE_END
+
+ASN1_ADB_SEQ(POLICYQUALINFO)
+	ADB_ENTRY(NID_id_qt_cps, ASN1_SIMPLE2(POLICYQUALINFO, d.cpsuri, ASN1_IA5STRING))
+	ADB_ENTRY(NID_id_qt_unotice, ASN1_SIMPLE2(POLICYQUALINFO, d.usernotice, USERNOTICE))
+ASN1_ADB_END(POLICYQUALINFO, 0, pqualid, 0, policydefault_tt, NULL)
 
-ASN1_ADB_TEMPLATE(policydefault) = ASN1_SIMPLE(POLICYQUALINFO, d.other, ASN1_ANY);
-
-ASN1_ADB(POLICYQUALINFO) = {
-	ADB_ENTRY(NID_id_qt_cps, ASN1_SIMPLE(POLICYQUALINFO, d.cpsuri, ASN1_IA5STRING)),
-	ADB_ENTRY(NID_id_qt_unotice, ASN1_SIMPLE(POLICYQUALINFO, d.usernotice, USERNOTICE))
-} ASN1_ADB_END(POLICYQUALINFO, 0, pqualid, 0, &policydefault_tt, NULL);
-
-ASN1_SEQUENCE(POLICYQUALINFO) = {
-	ASN1_SIMPLE(POLICYQUALINFO, pqualid, ASN1_OBJECT),
+ASN1_SEQUENCE(POLICYQUALINFO) 
+	ASN1_SIMPLE(POLICYQUALINFO, pqualid, ASN1_OBJECT)
 	ASN1_ADB_OBJECT(POLICYQUALINFO)
-} ASN1_SEQUENCE_END(POLICYQUALINFO)
+ASN1_SEQUENCE_END(POLICYQUALINFO)
 
-IMPLEMENT_ASN1_FUNCTIONS(POLICYQUALINFO)
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
+IMPLEMENT_ASN1_FUNCTIONS3(POLICYQUALINFO)
+#endif
 
-ASN1_SEQUENCE(USERNOTICE) = {
-	ASN1_OPT(USERNOTICE, noticeref, NOTICEREF),
+ASN1_SEQUENCE(USERNOTICE) 
+	ASN1_OPT(USERNOTICE, noticeref, NOTICEREF)
 	ASN1_OPT(USERNOTICE, exptext, DISPLAYTEXT)
-} ASN1_SEQUENCE_END(USERNOTICE)
+ASN1_SEQUENCE_END(USERNOTICE)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(USERNOTICE)
+#endif
 
-ASN1_SEQUENCE(NOTICEREF) = {
-	ASN1_SIMPLE(NOTICEREF, organization, DISPLAYTEXT),
+ASN1_SEQUENCE(NOTICEREF) 
+	ASN1_SIMPLE(NOTICEREF, organization, DISPLAYTEXT)
 	ASN1_SEQUENCE_OF(NOTICEREF, noticenos, ASN1_INTEGER)
-} ASN1_SEQUENCE_END(NOTICEREF)
+ASN1_SEQUENCE_END(NOTICEREF)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(NOTICEREF)
+#endif
 
+#ifndef OPERA_SMALL_VERSION
 static STACK_OF(POLICYINFO) *r2i_certpol(X509V3_EXT_METHOD *method,
 		X509V3_CTX *ctx, char *value)
 {
@@ -157,7 +177,7 @@
 			goto err;
 		}
 		pstr = cnf->name;
-		if(!strcmp(pstr,"ia5org")) {
+		if(!op_strcmp(pstr,"ia5org")) {
 			ia5org = 1;
 			continue;
 		} else if(*pstr == '@') {
@@ -205,7 +225,7 @@
 	if(!(pol = POLICYINFO_new())) goto merr;
 	for(i = 0; i < sk_CONF_VALUE_num(polstrs); i++) {
 		cnf = sk_CONF_VALUE_value(polstrs, i);
-		if(!strcmp(cnf->name, "policyIdentifier")) {
+		if(!op_strcmp(cnf->name, "policyIdentifier")) {
 			ASN1_OBJECT *pobj;
 			if(!(pobj = OBJ_txt2obj(cnf->value, 0))) {
 				X509V3err(X509V3_F_POLICY_SECTION,X509V3_R_INVALID_OBJECT_IDENTIFIER);
@@ -223,7 +243,7 @@
 			qual->pqualid = OBJ_nid2obj(NID_id_qt_cps);
 			qual->d.cpsuri = M_ASN1_IA5STRING_new();
 			if(!ASN1_STRING_set(qual->d.cpsuri, cnf->value,
-						 strlen(cnf->value))) goto merr;
+						 op_strlen(cnf->value))) goto merr;
 		} else if(!name_cmp(cnf->name, "userNotice")) {
 			STACK_OF(CONF_VALUE) *unot;
 			if(*cnf->value != '@') {
@@ -282,11 +302,11 @@
 	qual->d.usernotice = not;
 	for(i = 0; i < sk_CONF_VALUE_num(unot); i++) {
 		cnf = sk_CONF_VALUE_value(unot, i);
-		if(!strcmp(cnf->name, "explicitText")) {
+		if(!op_strcmp(cnf->name, "explicitText")) {
 			not->exptext = M_ASN1_VISIBLESTRING_new();
 			if(!ASN1_STRING_set(not->exptext, cnf->value,
-						 strlen(cnf->value))) goto merr;
-		} else if(!strcmp(cnf->name, "organization")) {
+						 op_strlen(cnf->value))) goto merr;
+		} else if(!op_strcmp(cnf->name, "organization")) {
 			NOTICEREF *nref;
 			if(!not->noticeref) {
 				if(!(nref = NOTICEREF_new())) goto merr;
@@ -295,8 +315,8 @@
 			if(ia5org) nref->organization->type = V_ASN1_IA5STRING;
 			else nref->organization->type = V_ASN1_VISIBLESTRING;
 			if(!ASN1_STRING_set(nref->organization, cnf->value,
-						 strlen(cnf->value))) goto merr;
-		} else if(!strcmp(cnf->name, "noticeNumbers")) {
+						 op_strlen(cnf->value))) goto merr;
+		} else if(!op_strcmp(cnf->name, "noticeNumbers")) {
 			NOTICEREF *nref;
 			STACK_OF(CONF_VALUE) *nos;
 			if(!not->noticeref) {
@@ -360,6 +380,7 @@
 	sk_ASN1_INTEGER_pop_free(nnums, ASN1_STRING_free);
 	return 0;
 }
+#endif
 
 
 static int i2r_certpol(X509V3_EXT_METHOD *method, STACK_OF(POLICYINFO) *pol,
@@ -435,6 +456,7 @@
 							 notice->exptext->data);
 }
 
+#ifndef OPERA_SMALL_VERSION
 void X509_POLICY_NODE_print(BIO *out, X509_POLICY_NODE *node, int indent)
 	{
 	const X509_POLICY_DATA *dat = node->data;
@@ -450,6 +472,7 @@
 	else
 		BIO_printf(out, "%*sNo Qualifiers\n", indent + 2, "");
 	}
+#endif
 
 
 IMPLEMENT_STACK_OF(X509_POLICY_NODE)
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_crld.c openssl-1.0.0q/crypto/x509v3/v3_crld.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_crld.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_crld.c	2017-04-25 16:23:40.875797340 +0200
@@ -56,39 +56,44 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/conf.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
+
+#ifndef OPERA_SMALL_VERSION
 static void *v2i_crld(const X509V3_EXT_METHOD *method,
 		      X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *nval);
+#endif // !OPERA_SMALL_VERSION
+
 static int i2r_crldp(const X509V3_EXT_METHOD *method, void *pcrldp, BIO *out,
 		     int indent);
 
-const X509V3_EXT_METHOD v3_crld =
-	{
+CONST_X509V3_EXT_METHOD_item(v3_crld,
 	NID_crl_distribution_points, 0, ASN1_ITEM_ref(CRL_DIST_POINTS),
 	0,0,0,0,
 	0,0,
 	0,
-	v2i_crld,
+	OPERA_V2I_DECLARE((X509V3_EXT_V2I)v2i_crld),
 	i2r_crldp,0,
 	NULL
-	};
+	);
 
-const X509V3_EXT_METHOD v3_freshest_crl =
-	{
+CONST_X509V3_EXT_METHOD_item(v3_freshest_crl,
 	NID_freshest_crl, 0, ASN1_ITEM_ref(CRL_DIST_POINTS),
 	0,0,0,0,
 	0,0,
 	0,
-	v2i_crld,
+	OPERA_V2I_DECLARE((X509V3_EXT_V2I)v2i_crld),
 	i2r_crldp,0,
 	NULL
-	};
+	);
 
 static STACK_OF(GENERAL_NAME) *gnames_from_sectname(X509V3_CTX *ctx, char *sect)
 	{
@@ -190,18 +195,19 @@
 	return -1;
 	}
 
-static const BIT_STRING_BITNAME reason_flags[] = {
-{0, "Unused", "unused"},
-{1, "Key Compromise", "keyCompromise"},
-{2, "CA Compromise", "CACompromise"},
-{3, "Affiliation Changed", "affiliationChanged"},
-{4, "Superseded", "superseded"},
-{5, "Cessation Of Operation", "cessationOfOperation"},
-{6, "Certificate Hold", "certificateHold"},
-{7, "Privilege Withdrawn", "privilegeWithdrawn"},
-{8, "AA Compromise", "AACompromise"},
-{-1, NULL, NULL}
-};
+OPENSSL_PREFIX_CONST_ARRAY(static, BIT_STRING_BITNAME, v3_crld__reason_flags, libopeay)
+CONST_BIT_STRING_BITNAME_ENTRY(0, "Unused", "unused")
+CONST_BIT_STRING_BITNAME_ENTRY(1, "Key Compromise", "keyCompromise")
+CONST_BIT_STRING_BITNAME_ENTRY(2, "CA Compromise", "CACompromise")
+CONST_BIT_STRING_BITNAME_ENTRY(3, "Affiliation Changed", "affiliationChanged")
+CONST_BIT_STRING_BITNAME_ENTRY(4, "Superseded", "superseded")
+CONST_BIT_STRING_BITNAME_ENTRY(5, "Cessation Of Operation", "cessationOfOperation")
+CONST_BIT_STRING_BITNAME_ENTRY(6, "Certificate Hold", "certificateHold")
+CONST_BIT_STRING_BITNAME_ENTRY(7, "Privilege Withdrawn", "privilegeWithdrawn")
+CONST_BIT_STRING_BITNAME_ENTRY(8, "AA Compromise", "AACompromise")
+CONST_BIT_STRING_BITNAME_ENTRY(-1, NULL, NULL)
+CONST_END(v3_crld__reason_flags)
+#define reason_flags OPENSSL_GLOBAL_ARRAY_NAME(v3_crld__reason_flags)
 
 static int set_reasons(ASN1_BIT_STRING **preas, char *value)
 	{
@@ -267,6 +273,7 @@
 	return 1;
 	}
 
+#ifndef OPERA_SMALL_VERSION
 static DIST_POINT *crldp_from_section(X509V3_CTX *ctx,
 						STACK_OF(CONF_VALUE) *nval)
 	{
@@ -307,7 +314,9 @@
 		DIST_POINT_free(point);
 	return NULL;
 	}
+#endif // !OPERA_SMALL_VERSION
 
+#ifndef OPERA_SMALL_VERSION
 static void *v2i_crld(const X509V3_EXT_METHOD *method,
 		      X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *nval)
 	{
@@ -369,6 +378,7 @@
 	sk_DIST_POINT_pop_free(crld, DIST_POINT_free);
 	return NULL;
 }
+#endif // !OPERA_SMALL_VERSION
 
 IMPLEMENT_STACK_OF(DIST_POINT)
 IMPLEMENT_ASN1_SET_OF(DIST_POINT)
@@ -393,36 +403,36 @@
 	}
 
 
-ASN1_CHOICE_cb(DIST_POINT_NAME, dpn_cb) = {
-	ASN1_IMP_SEQUENCE_OF(DIST_POINT_NAME, name.fullname, GENERAL_NAME, 0),
+ASN1_CHOICE_cb(DIST_POINT_NAME, dpn_cb)
+	ASN1_IMP_SEQUENCE_OF(DIST_POINT_NAME, name.fullname, GENERAL_NAME, 0)
 	ASN1_IMP_SET_OF(DIST_POINT_NAME, name.relativename, X509_NAME_ENTRY, 1)
-} ASN1_CHOICE_END_cb(DIST_POINT_NAME, DIST_POINT_NAME, type)
+ASN1_CHOICE_END_cb(DIST_POINT_NAME, DIST_POINT_NAME, type)
 
 
 IMPLEMENT_ASN1_FUNCTIONS(DIST_POINT_NAME)
 
-ASN1_SEQUENCE(DIST_POINT) = {
-	ASN1_EXP_OPT(DIST_POINT, distpoint, DIST_POINT_NAME, 0),
-	ASN1_IMP_OPT(DIST_POINT, reasons, ASN1_BIT_STRING, 1),
+ASN1_SEQUENCE(DIST_POINT)
+	ASN1_EXP_OPT(DIST_POINT, distpoint, DIST_POINT_NAME, 0)
+	ASN1_IMP_OPT(DIST_POINT, reasons, ASN1_BIT_STRING, 1)
 	ASN1_IMP_SEQUENCE_OF_OPT(DIST_POINT, CRLissuer, GENERAL_NAME, 2)
-} ASN1_SEQUENCE_END(DIST_POINT)
+ASN1_SEQUENCE_END(DIST_POINT)
 
 IMPLEMENT_ASN1_FUNCTIONS(DIST_POINT)
 
-ASN1_ITEM_TEMPLATE(CRL_DIST_POINTS) = 
+ASN1_ITEM_TEMPLATE(CRL_DIST_POINTS)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, CRLDistributionPoints, DIST_POINT)
 ASN1_ITEM_TEMPLATE_END(CRL_DIST_POINTS)
 
 IMPLEMENT_ASN1_FUNCTIONS(CRL_DIST_POINTS)
 
-ASN1_SEQUENCE(ISSUING_DIST_POINT) = {
-	ASN1_EXP_OPT(ISSUING_DIST_POINT, distpoint, DIST_POINT_NAME, 0),
-	ASN1_IMP_OPT(ISSUING_DIST_POINT, onlyuser, ASN1_FBOOLEAN, 1),
-	ASN1_IMP_OPT(ISSUING_DIST_POINT, onlyCA, ASN1_FBOOLEAN, 2),
-	ASN1_IMP_OPT(ISSUING_DIST_POINT, onlysomereasons, ASN1_BIT_STRING, 3),
-	ASN1_IMP_OPT(ISSUING_DIST_POINT, indirectCRL, ASN1_FBOOLEAN, 4),
+ASN1_SEQUENCE(ISSUING_DIST_POINT)
+	ASN1_EXP_OPT(ISSUING_DIST_POINT, distpoint, DIST_POINT_NAME, 0)
+	ASN1_IMP_OPT(ISSUING_DIST_POINT, onlyuser, ASN1_FBOOLEAN, 1)
+	ASN1_IMP_OPT(ISSUING_DIST_POINT, onlyCA, ASN1_FBOOLEAN, 2)
+	ASN1_IMP_OPT(ISSUING_DIST_POINT, onlysomereasons, ASN1_BIT_STRING, 3)
+	ASN1_IMP_OPT(ISSUING_DIST_POINT, indirectCRL, ASN1_FBOOLEAN, 4)
 	ASN1_IMP_OPT(ISSUING_DIST_POINT, onlyattr, ASN1_FBOOLEAN, 5)
-} ASN1_SEQUENCE_END(ISSUING_DIST_POINT)
+ASN1_SEQUENCE_END(ISSUING_DIST_POINT)
 
 IMPLEMENT_ASN1_FUNCTIONS(ISSUING_DIST_POINT)
 
@@ -431,8 +441,7 @@
 static void *v2i_idp(const X509V3_EXT_METHOD *method, X509V3_CTX *ctx,
 		     STACK_OF(CONF_VALUE) *nval);
 
-const X509V3_EXT_METHOD v3_idp =
-	{
+CONST_X509V3_EXT_METHOD_item(v3_idp,
 	NID_issuing_distribution_point, X509V3_EXT_MULTILINE,
 	ASN1_ITEM_ref(ISSUING_DIST_POINT),
 	0,0,0,0,
@@ -441,7 +450,7 @@
 	v2i_idp,
 	i2r_idp,0,
 	NULL
-	};
+	);
 
 static void *v2i_idp(const X509V3_EXT_METHOD *method, X509V3_CTX *ctx,
 		     STACK_OF(CONF_VALUE) *nval)
@@ -538,7 +547,7 @@
 static int i2r_idp(const X509V3_EXT_METHOD *method, void *pidp, BIO *out,
 		   int indent)
 	{
-	ISSUING_DIST_POINT *idp = pidp;
+	ISSUING_DIST_POINT *idp = (ISSUING_DIST_POINT *)pidp;
 	if (idp->distpoint)
 		print_distpoint(out, idp->distpoint, indent);
 	if (idp->onlyuser > 0)
@@ -563,7 +572,7 @@
 static int i2r_crldp(const X509V3_EXT_METHOD *method, void *pcrldp, BIO *out,
 		     int indent)
 	{
-	STACK_OF(DIST_POINT) *crld = pcrldp;
+	STACK_OF(DIST_POINT) *crld = (STACK_OF(DIST_POINT) *)pcrldp;
 	DIST_POINT *point;
 	int i;
 	for(i = 0; i < sk_DIST_POINT_num(crld); i++)
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_enum.c openssl-1.0.0q/crypto/x509v3/v3_enum.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_enum.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_enum.c	2017-04-25 16:23:40.875797340 +0200
@@ -56,42 +56,46 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
-static ENUMERATED_NAMES crl_reasons[] = {
-{CRL_REASON_UNSPECIFIED, 	 "Unspecified", "unspecified"},
-{CRL_REASON_KEY_COMPROMISE,	 "Key Compromise", "keyCompromise"},
-{CRL_REASON_CA_COMPROMISE,	 "CA Compromise", "CACompromise"},
-{CRL_REASON_AFFILIATION_CHANGED, "Affiliation Changed", "affiliationChanged"},
-{CRL_REASON_SUPERSEDED, 	 "Superseded", "superseded"},
-{CRL_REASON_CESSATION_OF_OPERATION,
-			"Cessation Of Operation", "cessationOfOperation"},
-{CRL_REASON_CERTIFICATE_HOLD,	 "Certificate Hold", "certificateHold"},
-{CRL_REASON_REMOVE_FROM_CRL,	 "Remove From CRL", "removeFromCRL"},
-{CRL_REASON_PRIVILEGE_WITHDRAWN, "Privilege Withdrawn", "privilegeWithdrawn"},
-{CRL_REASON_AA_COMPROMISE,	 "AA Compromise", "AACompromise"},
-{-1, NULL, NULL}
-};
+OPENSSL_PREFIX_CONST_ARRAY(static, ENUMERATED_NAMES, crl_reasons, libopeay)
+	CONST_BIT_STRING_BITNAME_ENTRY(CRL_REASON_UNSPECIFIED, "Unspecified", "unspecified")
+	CONST_BIT_STRING_BITNAME_ENTRY(CRL_REASON_KEY_COMPROMISE, "Key Compromise", "keyCompromise")
+	CONST_BIT_STRING_BITNAME_ENTRY(CRL_REASON_CA_COMPROMISE, "CA Compromise", "CACompromise")
+	CONST_BIT_STRING_BITNAME_ENTRY(CRL_REASON_AFFILIATION_CHANGED, "Affiliation Changed", "affiliationChanged")
+	CONST_BIT_STRING_BITNAME_ENTRY(CRL_REASON_SUPERSEDED, "Superseded", "superseded")
+	CONST_BIT_STRING_BITNAME_ENTRY(CRL_REASON_CESSATION_OF_OPERATION, "Cessation Of Operation", "cessationOfOperation")
+	CONST_BIT_STRING_BITNAME_ENTRY(CRL_REASON_CERTIFICATE_HOLD, "Certificate Hold", "certificateHold")
+	CONST_BIT_STRING_BITNAME_ENTRY(CRL_REASON_REMOVE_FROM_CRL, "Remove From CRL", "removeFromCRL")
+	CONST_BIT_STRING_BITNAME_ENTRY(CRL_REASON_PRIVILEGE_WITHDRAWN, "Privilege Withdrawn", "privilegeWithdrawn")
+	CONST_BIT_STRING_BITNAME_ENTRY(CRL_REASON_AA_COMPROMISE,	 "AA Compromise", "AACompromise")
+	CONST_BIT_STRING_BITNAME_ENTRY(-1, NULL, NULL)
+CONST_END(crl_reasons)
 
-const X509V3_EXT_METHOD v3_crl_reason = { 
+CONST_X509V3_EXT_METHOD_item(v3_crl_reason, 
 NID_crl_reason, 0, ASN1_ITEM_ref(ASN1_ENUMERATED),
 0,0,0,0,
-(X509V3_EXT_I2S)i2s_ASN1_ENUMERATED_TABLE,
+OPERA_I2S_DECLARE((X509V3_EXT_I2S)i2s_ASN1_ENUMERATED_TABLE),
 0,
 0,0,0,0,
-crl_reasons};
+OPENSSL_GLOBAL_ARRAY_NAME(crl_reasons))
 
 
+#ifndef OPERA_SMALL_VERSION
 char *i2s_ASN1_ENUMERATED_TABLE(X509V3_EXT_METHOD *method,
 	     ASN1_ENUMERATED *e)
 {
-	ENUMERATED_NAMES *enam;
+	const ENUMERATED_NAMES *enam;
 	long strval;
 	strval = ASN1_ENUMERATED_get(e);
-	for(enam = method->usr_data; enam->lname; enam++) {
+	for(enam = (const ENUMERATED_NAMES *) method->usr_data; enam->lname; enam++) {
 		if(strval == enam->bitnum) return BUF_strdup(enam->lname);
 	}
 	return i2s_ASN1_ENUMERATED(method, e);
 }
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_extku.c openssl-1.0.0q/crypto/x509v3/v3_extku.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_extku.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_extku.c	2017-04-25 16:23:40.876799423 +0200
@@ -57,55 +57,62 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/conf.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
+#ifndef OPERA_SMALL_VERSION
 static void *v2i_EXTENDED_KEY_USAGE(const X509V3_EXT_METHOD *method,
 				    X509V3_CTX *ctx,
 				    STACK_OF(CONF_VALUE) *nval);
+#endif
 static STACK_OF(CONF_VALUE) *i2v_EXTENDED_KEY_USAGE(const X509V3_EXT_METHOD *method,
 		void *eku, STACK_OF(CONF_VALUE) *extlist);
 
-const X509V3_EXT_METHOD v3_ext_ku = {
+CONST_X509V3_EXT_METHOD_item(v3_ext_ku,
 	NID_ext_key_usage, 0,
 	ASN1_ITEM_ref(EXTENDED_KEY_USAGE),
 	0,0,0,0,
 	0,0,
 	i2v_EXTENDED_KEY_USAGE,
-	v2i_EXTENDED_KEY_USAGE,
+	OPERA_V2I_DECLARE(v2i_EXTENDED_KEY_USAGE),
 	0,0,
 	NULL
-};
+)
 
 /* NB OCSP acceptable responses also is a SEQUENCE OF OBJECT */
-const X509V3_EXT_METHOD v3_ocsp_accresp = {
+CONST_X509V3_EXT_METHOD_item(v3_ocsp_accresp,
 	NID_id_pkix_OCSP_acceptableResponses, 0,
 	ASN1_ITEM_ref(EXTENDED_KEY_USAGE),
 	0,0,0,0,
 	0,0,
 	i2v_EXTENDED_KEY_USAGE,
-	v2i_EXTENDED_KEY_USAGE,
+	OPERA_V2I_DECLARE(v2i_EXTENDED_KEY_USAGE),
 	0,0,
 	NULL
-};
+)
 
-ASN1_ITEM_TEMPLATE(EXTENDED_KEY_USAGE) = 
+ASN1_ITEM_TEMPLATE(EXTENDED_KEY_USAGE)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, EXTENDED_KEY_USAGE, ASN1_OBJECT)
 ASN1_ITEM_TEMPLATE_END(EXTENDED_KEY_USAGE)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(EXTENDED_KEY_USAGE)
+#endif
 
 static STACK_OF(CONF_VALUE) *
   i2v_EXTENDED_KEY_USAGE(const X509V3_EXT_METHOD *method, void *a,
 			 STACK_OF(CONF_VALUE) *ext_list)
 {
-	EXTENDED_KEY_USAGE *eku = a;
+	EXTENDED_KEY_USAGE *eku = (EXTENDED_KEY_USAGE *) a;
 	int i;
 	ASN1_OBJECT *obj;
-	char obj_tmp[80];
+	char obj_tmp[80];			/* ARRAY OK 2009-05-25 yngve */
 	for(i = 0; i < sk_ASN1_OBJECT_num(eku); i++) {
 		obj = sk_ASN1_OBJECT_value(eku, i);
 		i2t_ASN1_OBJECT(obj_tmp, 80, obj);
@@ -114,6 +121,7 @@
 	return ext_list;
 }
 
+#ifndef OPERA_SMALL_VERSION
 static void *v2i_EXTENDED_KEY_USAGE(const X509V3_EXT_METHOD *method,
 				    X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *nval)
 {
@@ -142,3 +150,4 @@
 	}
 	return extku;
 }
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_genn.c openssl-1.0.0q/crypto/x509v3/v3_genn.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_genn.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_genn.c	2017-04-25 16:23:40.877798991 +0200
@@ -57,55 +57,62 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/conf.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
-ASN1_SEQUENCE(OTHERNAME) = {
-	ASN1_SIMPLE(OTHERNAME, type_id, ASN1_OBJECT),
+ASN1_SEQUENCE(OTHERNAME) 
+	ASN1_SIMPLE(OTHERNAME, type_id, ASN1_OBJECT)
 	/* Maybe have a true ANY DEFINED BY later */
 	ASN1_EXP(OTHERNAME, value, ASN1_ANY, 0)
-} ASN1_SEQUENCE_END(OTHERNAME)
+ASN1_SEQUENCE_END(OTHERNAME)
 
 IMPLEMENT_ASN1_FUNCTIONS(OTHERNAME)
 
-ASN1_SEQUENCE(EDIPARTYNAME) = {
-	ASN1_IMP_OPT(EDIPARTYNAME, nameAssigner, DIRECTORYSTRING, 0),
+ASN1_SEQUENCE(EDIPARTYNAME) 
+	ASN1_IMP_OPT(EDIPARTYNAME, nameAssigner, DIRECTORYSTRING, 0)
 	ASN1_IMP_OPT(EDIPARTYNAME, partyName, DIRECTORYSTRING, 1)
-} ASN1_SEQUENCE_END(EDIPARTYNAME)
+ASN1_SEQUENCE_END(EDIPARTYNAME)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(EDIPARTYNAME)
+#endif
 
-ASN1_CHOICE(GENERAL_NAME) = {
-	ASN1_IMP(GENERAL_NAME, d.otherName, OTHERNAME, GEN_OTHERNAME),
-	ASN1_IMP(GENERAL_NAME, d.rfc822Name, ASN1_IA5STRING, GEN_EMAIL),
-	ASN1_IMP(GENERAL_NAME, d.dNSName, ASN1_IA5STRING, GEN_DNS),
+ASN1_CHOICE(GENERAL_NAME)
+	ASN1_IMP(GENERAL_NAME, d.otherName, OTHERNAME, GEN_OTHERNAME)
+	ASN1_IMP(GENERAL_NAME, d.rfc822Name, ASN1_IA5STRING, GEN_EMAIL)
+	ASN1_IMP(GENERAL_NAME, d.dNSName, ASN1_IA5STRING, GEN_DNS)
 	/* Don't decode this */
-	ASN1_IMP(GENERAL_NAME, d.x400Address, ASN1_SEQUENCE, GEN_X400),
+	ASN1_IMP(GENERAL_NAME, d.x400Address, ASN1_SEQUENCE, GEN_X400)
 	/* X509_NAME is a CHOICE type so use EXPLICIT */
-	ASN1_EXP(GENERAL_NAME, d.directoryName, X509_NAME, GEN_DIRNAME),
-	ASN1_IMP(GENERAL_NAME, d.ediPartyName, EDIPARTYNAME, GEN_EDIPARTY),
-	ASN1_IMP(GENERAL_NAME, d.uniformResourceIdentifier, ASN1_IA5STRING, GEN_URI),
-	ASN1_IMP(GENERAL_NAME, d.iPAddress, ASN1_OCTET_STRING, GEN_IPADD),
+	ASN1_EXP(GENERAL_NAME, d.directoryName, X509_NAME, GEN_DIRNAME)
+	ASN1_IMP(GENERAL_NAME, d.ediPartyName, EDIPARTYNAME, GEN_EDIPARTY)
+	ASN1_IMP(GENERAL_NAME, d.uniformResourceIdentifier, ASN1_IA5STRING, GEN_URI)
+	ASN1_IMP(GENERAL_NAME, d.iPAddress, ASN1_OCTET_STRING, GEN_IPADD)
 	ASN1_IMP(GENERAL_NAME, d.registeredID, ASN1_OBJECT, GEN_RID)
-} ASN1_CHOICE_END(GENERAL_NAME)
+ASN1_CHOICE_END(GENERAL_NAME)
 
 IMPLEMENT_ASN1_FUNCTIONS(GENERAL_NAME)
 
-ASN1_ITEM_TEMPLATE(GENERAL_NAMES) = 
+ASN1_ITEM_TEMPLATE(GENERAL_NAMES)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, GeneralNames, GENERAL_NAME)
 ASN1_ITEM_TEMPLATE_END(GENERAL_NAMES)
 
 IMPLEMENT_ASN1_FUNCTIONS(GENERAL_NAMES)
 
+#ifndef NO_OLD_ASN1
 GENERAL_NAME *GENERAL_NAME_dup(GENERAL_NAME *a)
 	{
 	return (GENERAL_NAME *) ASN1_dup((i2d_of_void *) i2d_GENERAL_NAME,
 					 (d2i_of_void *) d2i_GENERAL_NAME,
 					 (char *) a);
 	}
+#endif
 
 /* Returns 0 if they are equal, != 0 otherwise. */
 int GENERAL_NAME_cmp(GENERAL_NAME *a, GENERAL_NAME *b)
@@ -165,29 +172,29 @@
 		{
 	case GEN_X400:
 	case GEN_EDIPARTY:
-		a->d.other = value;
+		a->d.other = (ASN1_TYPE *)value;
 		break;
 
 	case GEN_OTHERNAME:
-		a->d.otherName = value;
+		a->d.otherName = (OTHERNAME *)value;
 		break;
 
 	case GEN_EMAIL:
 	case GEN_DNS:
 	case GEN_URI:
-		a->d.ia5 = value;
+		a->d.ia5 = (ASN1_IA5STRING *)value;
 		break;
 
 	case GEN_DIRNAME:
-		a->d.dirn = value;
+		a->d.dirn = (X509_NAME *)value;
 		break;
 
 	case GEN_IPADD:
-		a->d.ip = value;
+		a->d.ip = (ASN1_OCTET_STRING *)value;
 		break;
 	
 	case GEN_RID:
-		a->d.rid = value;
+		a->d.rid = (ASN1_OBJECT *)value;
 		break;
 		}
 	a->type = type;
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_ia5.c openssl-1.0.0q/crypto/x509v3/v3_ia5.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_ia5.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_ia5.c	2017-04-25 16:23:40.877798991 +0200
@@ -57,24 +57,30 @@
  */
 
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/conf.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 static char *i2s_ASN1_IA5STRING(X509V3_EXT_METHOD *method, ASN1_IA5STRING *ia5);
+#ifndef OPERA_SMALL_VERSION
 static ASN1_IA5STRING *s2i_ASN1_IA5STRING(X509V3_EXT_METHOD *method, X509V3_CTX *ctx, char *str);
-const X509V3_EXT_METHOD v3_ns_ia5_list[] = { 
-EXT_IA5STRING(NID_netscape_base_url),
-EXT_IA5STRING(NID_netscape_revocation_url),
-EXT_IA5STRING(NID_netscape_ca_revocation_url),
-EXT_IA5STRING(NID_netscape_renewal_url),
-EXT_IA5STRING(NID_netscape_ca_policy_url),
-EXT_IA5STRING(NID_netscape_ssl_server_name),
-EXT_IA5STRING(NID_netscape_comment),
+#endif
+
+OPENSSL_PREFIX_CONST_ARRAY(OPENSSL_EXTERN,X509V3_EXT_METHOD, v3_ns_ia5_list, libopeay)
+EXT_IA5STRING(NID_netscape_base_url)
+EXT_IA5STRING(NID_netscape_revocation_url)
+EXT_IA5STRING(NID_netscape_ca_revocation_url)
+EXT_IA5STRING(NID_netscape_renewal_url)
+EXT_IA5STRING(NID_netscape_ca_policy_url)
+EXT_IA5STRING(NID_netscape_ssl_server_name)
+EXT_IA5STRING(NID_netscape_comment)
 EXT_END
-};
+CONST_END(v3_ns_ia5_list)
 
 
 static char *i2s_ASN1_IA5STRING(X509V3_EXT_METHOD *method,
@@ -82,15 +88,16 @@
 {
 	char *tmp;
 	if(!ia5 || !ia5->length) return NULL;
-	if(!(tmp = OPENSSL_malloc(ia5->length + 1))) {
+	if(!(tmp = (char *) OPENSSL_malloc(ia5->length + 1))) {
 		X509V3err(X509V3_F_I2S_ASN1_IA5STRING,ERR_R_MALLOC_FAILURE);
 		return NULL;
 	}
-	memcpy(tmp, ia5->data, ia5->length);
+	op_memcpy(tmp, ia5->data, ia5->length);
 	tmp[ia5->length] = 0;
 	return tmp;
 }
 
+#ifndef OPERA_SMALL_VERSION
 static ASN1_IA5STRING *s2i_ASN1_IA5STRING(X509V3_EXT_METHOD *method,
 	     X509V3_CTX *ctx, char *str)
 {
@@ -101,7 +108,7 @@
 	}
 	if(!(ia5 = M_ASN1_IA5STRING_new())) goto err;
 	if(!ASN1_STRING_set((ASN1_STRING *)ia5, (unsigned char*)str,
-			    strlen(str))) {
+			    op_strlen(str))) {
 		M_ASN1_IA5STRING_free(ia5);
 		goto err;
 	}
@@ -113,4 +120,5 @@
 	X509V3err(X509V3_F_S2I_ASN1_IA5STRING,ERR_R_MALLOC_FAILURE);
 	return NULL;
 }
+#endif
 
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_info.c openssl-1.0.0q/crypto/x509v3/v3_info.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_info.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_info.c	2017-04-25 16:23:40.878798000 +0200
@@ -56,49 +56,55 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/conf.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 static STACK_OF(CONF_VALUE) *i2v_AUTHORITY_INFO_ACCESS(X509V3_EXT_METHOD *method,
 				AUTHORITY_INFO_ACCESS *ainfo,
 						STACK_OF(CONF_VALUE) *ret);
+#ifndef OPERA_SMALL_VERSION
 static AUTHORITY_INFO_ACCESS *v2i_AUTHORITY_INFO_ACCESS(X509V3_EXT_METHOD *method,
 				 X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *nval);
-
-const X509V3_EXT_METHOD v3_info =
-{ NID_info_access, X509V3_EXT_MULTILINE, ASN1_ITEM_ref(AUTHORITY_INFO_ACCESS),
+#endif
+CONST_X509V3_EXT_METHOD_item(v3_info,
+NID_info_access, X509V3_EXT_MULTILINE, ASN1_ITEM_ref(AUTHORITY_INFO_ACCESS),
 0,0,0,0,
 0,0,
 (X509V3_EXT_I2V)i2v_AUTHORITY_INFO_ACCESS,
-(X509V3_EXT_V2I)v2i_AUTHORITY_INFO_ACCESS,
+OPERA_V2I_DECLARE((X509V3_EXT_V2I)v2i_AUTHORITY_INFO_ACCESS),
 0,0,
-NULL};
+NULL)
 
-const X509V3_EXT_METHOD v3_sinfo =
-{ NID_sinfo_access, X509V3_EXT_MULTILINE, ASN1_ITEM_ref(AUTHORITY_INFO_ACCESS),
+CONST_X509V3_EXT_METHOD_item(v3_sinfo,
+NID_sinfo_access, X509V3_EXT_MULTILINE, ASN1_ITEM_ref(AUTHORITY_INFO_ACCESS),
 0,0,0,0,
 0,0,
 (X509V3_EXT_I2V)i2v_AUTHORITY_INFO_ACCESS,
-(X509V3_EXT_V2I)v2i_AUTHORITY_INFO_ACCESS,
+OPERA_V2I_DECLARE((X509V3_EXT_V2I)v2i_AUTHORITY_INFO_ACCESS),
 0,0,
-NULL};
+NULL)
 
-ASN1_SEQUENCE(ACCESS_DESCRIPTION) = {
-	ASN1_SIMPLE(ACCESS_DESCRIPTION, method, ASN1_OBJECT),
+ASN1_SEQUENCE(ACCESS_DESCRIPTION)
+	ASN1_SIMPLE(ACCESS_DESCRIPTION, method, ASN1_OBJECT)
 	ASN1_SIMPLE(ACCESS_DESCRIPTION, location, GENERAL_NAME)
-} ASN1_SEQUENCE_END(ACCESS_DESCRIPTION)
+ASN1_SEQUENCE_END(ACCESS_DESCRIPTION)
 
-IMPLEMENT_ASN1_FUNCTIONS(ACCESS_DESCRIPTION)
+IMPLEMENT_ASN1_FUNCTIONS3(ACCESS_DESCRIPTION)
 
-ASN1_ITEM_TEMPLATE(AUTHORITY_INFO_ACCESS) = 
+ASN1_ITEM_TEMPLATE(AUTHORITY_INFO_ACCESS)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, GeneralNames, ACCESS_DESCRIPTION)
 ASN1_ITEM_TEMPLATE_END(AUTHORITY_INFO_ACCESS)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(AUTHORITY_INFO_ACCESS)
+#endif
 
 static STACK_OF(CONF_VALUE) *i2v_AUTHORITY_INFO_ACCESS(X509V3_EXT_METHOD *method,
 				AUTHORITY_INFO_ACCESS *ainfo,
@@ -114,8 +120,8 @@
 		if(!ret) break;
 		vtmp = sk_CONF_VALUE_value(ret, i);
 		i2t_ASN1_OBJECT(objtmp, sizeof objtmp, desc->method);
-		nlen = strlen(objtmp) + strlen(vtmp->name) + 5;
-		ntmp = OPENSSL_malloc(nlen);
+		nlen = op_strlen(objtmp) + op_strlen(vtmp->name) + 5;
+		ntmp = (char *) OPENSSL_malloc(nlen);
 		if(!ntmp) {
 			X509V3err(X509V3_F_I2V_AUTHORITY_INFO_ACCESS,
 					ERR_R_MALLOC_FAILURE);
@@ -132,6 +138,7 @@
 	return ret;
 }
 
+#ifndef OPERA_SMALL_VERSION
 static AUTHORITY_INFO_ACCESS *v2i_AUTHORITY_INFO_ACCESS(X509V3_EXT_METHOD *method,
 				 X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *nval)
 {
@@ -151,7 +158,7 @@
 			X509V3err(X509V3_F_V2I_AUTHORITY_INFO_ACCESS,ERR_R_MALLOC_FAILURE);
 			goto err;
 		}
-		ptmp = strchr(cnf->name, ';');
+		ptmp = op_strchr(cnf->name, ';');
 		if(!ptmp) {
 			X509V3err(X509V3_F_V2I_AUTHORITY_INFO_ACCESS,X509V3_R_INVALID_SYNTAX);
 			goto err;
@@ -165,12 +172,14 @@
 			X509V3err(X509V3_F_V2I_AUTHORITY_INFO_ACCESS,ERR_R_MALLOC_FAILURE);
 			goto err;
 		}
-		strncpy(objtmp, cnf->name, objlen);
+		op_strncpy(objtmp, cnf->name, objlen);
 		objtmp[objlen] = 0;
 		acc->method = OBJ_txt2obj(objtmp, 0);
 		if(!acc->method) {
 			X509V3err(X509V3_F_V2I_AUTHORITY_INFO_ACCESS,X509V3_R_BAD_OBJECT);
+#ifndef OPERA_SMALL_VERSION
 			ERR_add_error_data(2, "value=", objtmp);
+#endif
 			OPENSSL_free(objtmp);
 			goto err;
 		}
@@ -191,3 +200,4 @@
 #endif
 	return 2;
 	}
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_int.c openssl-1.0.0q/crypto/x509v3/v3_int.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_int.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_int.c	2017-04-25 16:23:40.879798686 +0200
@@ -56,34 +56,39 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
-const X509V3_EXT_METHOD v3_crl_num = { 
+CONST_X509V3_EXT_METHOD_item(v3_crl_num,
 	NID_crl_number, 0, ASN1_ITEM_ref(ASN1_INTEGER),
 	0,0,0,0,
 	(X509V3_EXT_I2S)i2s_ASN1_INTEGER,
 	0,
-	0,0,0,0, NULL};
+	0,0,0,0, NULL)
 
-const X509V3_EXT_METHOD v3_delta_crl = { 
+CONST_X509V3_EXT_METHOD_item(v3_delta_crl, 
 	NID_delta_crl, 0, ASN1_ITEM_ref(ASN1_INTEGER),
 	0,0,0,0,
 	(X509V3_EXT_I2S)i2s_ASN1_INTEGER,
 	0,
-	0,0,0,0, NULL};
+	0,0,0,0, NULL)
 
+#ifndef OPERA_SMALL_VERSION
 static void * s2i_asn1_int(X509V3_EXT_METHOD *meth, X509V3_CTX *ctx, char *value)
 	{
 	return s2i_ASN1_INTEGER(meth, value);
 	}
+#endif
 
-const X509V3_EXT_METHOD v3_inhibit_anyp = { 
+CONST_X509V3_EXT_METHOD_item(v3_inhibit_anyp,
 	NID_inhibit_any_policy, 0, ASN1_ITEM_ref(ASN1_INTEGER),
 	0,0,0,0,
 	(X509V3_EXT_I2S)i2s_ASN1_INTEGER,
-	(X509V3_EXT_S2I)s2i_asn1_int,
-	0,0,0,0, NULL};
+	OPERA_S2I_DECLARE((X509V3_EXT_S2I)s2i_asn1_int),
+	0,0,0,0, NULL)
 
 
